## Patch Pool `client.LoadBalancers.Pools.Edit(ctx, poolID, params) (*Pool, error)` **patch** `/accounts/{account_id}/load_balancers/pools/{pool_id}` Apply changes to an existing pool, overwriting the supplied properties. ### Parameters - `poolID string` - `params PoolEditParams` - `AccountID param.Field[string]` Path param: Identifier. - `CheckRegions param.Field[[]CheckRegion]` Body param: A list of regions from which to run health checks. Null means every Cloudflare data center. - `const CheckRegionWnam CheckRegion = "WNAM"` - `const CheckRegionEnam CheckRegion = "ENAM"` - `const CheckRegionWeu CheckRegion = "WEU"` - `const CheckRegionEeu CheckRegion = "EEU"` - `const CheckRegionNsam CheckRegion = "NSAM"` - `const CheckRegionSsam CheckRegion = "SSAM"` - `const CheckRegionOc CheckRegion = "OC"` - `const CheckRegionMe CheckRegion = "ME"` - `const CheckRegionNaf CheckRegion = "NAF"` - `const CheckRegionSaf CheckRegion = "SAF"` - `const CheckRegionSas CheckRegion = "SAS"` - `const CheckRegionSeas CheckRegion = "SEAS"` - `const CheckRegionNeas CheckRegion = "NEAS"` - `const CheckRegionAllRegions CheckRegion = "ALL_REGIONS"` - `Description param.Field[string]` Body param: A human-readable description of the pool. - `Enabled param.Field[bool]` Body param: Whether to enable (the default) or disable this pool. Disabled pools will not receive traffic and are excluded from health checks. Disabling a pool will cause any load balancers using it to failover to the next pool (if any). - `Latitude param.Field[float64]` Body param: The latitude of the data center containing the origins used in this pool in decimal degrees. If this is set, longitude must also be set. - `LoadShedding param.Field[LoadShedding]` Body param: Configures load shedding policies and percentages for the pool. - `Longitude param.Field[float64]` Body param: The longitude of the data center containing the origins used in this pool in decimal degrees. If this is set, latitude must also be set. - `MinimumOrigins param.Field[int64]` Body param: The minimum number of origins that must be healthy for this pool to serve traffic. If the number of healthy origins falls below this number, the pool will be marked unhealthy and will failover to the next available pool. - `Monitor param.Field[string]` Body param: The ID of the Monitor to use for checking the health of origins within this pool. - `MonitorGroup param.Field[string]` Body param: The ID of the Monitor Group to use for checking the health of origins within this pool. - `Name param.Field[string]` Body param: A short name (tag) for the pool. Only alphanumeric characters, hyphens, and underscores are allowed. - `NotificationEmail param.Field[string]` Body param: This field is now deprecated. It has been moved to Cloudflare's Centralized Notification service https://developers.cloudflare.com/fundamentals/notifications/. The email address to send health status notifications to. This can be an individual mailbox or a mailing list. Multiple emails can be supplied as a comma delimited list. - `NotificationFilter param.Field[NotificationFilter]` Body param: Filter pool and origin health notifications by resource type or health status. Use null to reset. - `OriginSteering param.Field[OriginSteering]` Body param: Configures origin steering for the pool. Controls how origins are selected for new sessions and traffic without session affinity. - `Origins param.Field[[]Origin]` Body param: The list of origins within this pool. Traffic directed at this pool is balanced across all currently healthy origins, provided the pool itself is healthy. - `Address string` The IP address (IPv4 or IPv6) of the origin, or its publicly addressable hostname. Hostnames entered here should resolve directly to the origin, and not be a hostname proxied by Cloudflare. To set an internal/reserved address, virtual_network_id must also be set. - `DisabledAt Time` This field shows up only if the origin is disabled. This field is set with the time the origin was disabled. - `Enabled bool` Whether to enable (the default) this origin within the pool. Disabled origins will not receive traffic and are excluded from health checks. The origin will only be disabled for the current pool. - `Header Header` The request header is used to pass additional information with an HTTP request. Currently supported header is 'Host'. - `Host []Host` The 'Host' header allows to override the hostname set in the HTTP request. Current support is 1 'Host' header override per origin. - `Name string` A human-identifiable name for the origin. - `Port int64` The port for upstream connections. A value of 0 means the default port for the protocol will be used. - `VirtualNetworkID string` The virtual network subnet ID the origin belongs in. Virtual network must also belong to the account. - `Weight float64` The weight of this origin relative to other origins in the pool. Based on the configured weight the total traffic is distributed among origins within the pool. - `origin_steering.policy="least_outstanding_requests"`: Use weight to scale the origin's outstanding requests. - `origin_steering.policy="least_connections"`: Use weight to scale the origin's open connections. ### Returns - `type Pool struct{…}` - `ID string` - `CheckRegions []CheckRegion` A list of regions from which to run health checks. Null means every Cloudflare data center. - `const CheckRegionWnam CheckRegion = "WNAM"` - `const CheckRegionEnam CheckRegion = "ENAM"` - `const CheckRegionWeu CheckRegion = "WEU"` - `const CheckRegionEeu CheckRegion = "EEU"` - `const CheckRegionNsam CheckRegion = "NSAM"` - `const CheckRegionSsam CheckRegion = "SSAM"` - `const CheckRegionOc CheckRegion = "OC"` - `const CheckRegionMe CheckRegion = "ME"` - `const CheckRegionNaf CheckRegion = "NAF"` - `const CheckRegionSaf CheckRegion = "SAF"` - `const CheckRegionSas CheckRegion = "SAS"` - `const CheckRegionSeas CheckRegion = "SEAS"` - `const CheckRegionNeas CheckRegion = "NEAS"` - `const CheckRegionAllRegions CheckRegion = "ALL_REGIONS"` - `CreatedOn string` - `Description string` A human-readable description of the pool. - `DisabledAt Time` This field shows up only if the pool is disabled. This field is set with the time the pool was disabled at. - `Enabled bool` Whether to enable (the default) or disable this pool. Disabled pools will not receive traffic and are excluded from health checks. Disabling a pool will cause any load balancers using it to failover to the next pool (if any). - `Latitude float64` The latitude of the data center containing the origins used in this pool in decimal degrees. If this is set, longitude must also be set. - `LoadShedding LoadShedding` Configures load shedding policies and percentages for the pool. - `DefaultPercent float64` The percent of traffic to shed from the pool, according to the default policy. Applies to new sessions and traffic without session affinity. - `DefaultPolicy LoadSheddingDefaultPolicy` The default policy to use when load shedding. A random policy randomly sheds a given percent of requests. A hash policy computes a hash over the CF-Connecting-IP address and sheds all requests originating from a percent of IPs. - `const LoadSheddingDefaultPolicyRandom LoadSheddingDefaultPolicy = "random"` - `const LoadSheddingDefaultPolicyHash LoadSheddingDefaultPolicy = "hash"` - `SessionPercent float64` The percent of existing sessions to shed from the pool, according to the session policy. - `SessionPolicy LoadSheddingSessionPolicy` Only the hash policy is supported for existing sessions (to avoid exponential decay). - `const LoadSheddingSessionPolicyHash LoadSheddingSessionPolicy = "hash"` - `Longitude float64` The longitude of the data center containing the origins used in this pool in decimal degrees. If this is set, latitude must also be set. - `MinimumOrigins int64` The minimum number of origins that must be healthy for this pool to serve traffic. If the number of healthy origins falls below this number, the pool will be marked unhealthy and will failover to the next available pool. - `ModifiedOn string` - `Monitor string` The ID of the Monitor to use for checking the health of origins within this pool. - `MonitorGroup string` The ID of the Monitor Group to use for checking the health of origins within this pool. - `Name string` A short name (tag) for the pool. Only alphanumeric characters, hyphens, and underscores are allowed. - `Networks []string` List of networks where Load Balancer or Pool is enabled. - `NotificationEmail string` This field is now deprecated. It has been moved to Cloudflare's Centralized Notification service https://developers.cloudflare.com/fundamentals/notifications/. The email address to send health status notifications to. This can be an individual mailbox or a mailing list. Multiple emails can be supplied as a comma delimited list. - `NotificationFilter NotificationFilter` Filter pool and origin health notifications by resource type or health status. Use null to reset. - `Origin FilterOptions` Filter options for a particular resource type (pool or origin). Use null to reset. - `Disable bool` If set true, disable notifications for this type of resource (pool or origin). - `Healthy bool` If present, send notifications only for this health status (e.g. false for only DOWN events). Use null to reset (all events). - `Pool FilterOptions` Filter options for a particular resource type (pool or origin). Use null to reset. - `OriginSteering OriginSteering` Configures origin steering for the pool. Controls how origins are selected for new sessions and traffic without session affinity. - `Policy OriginSteeringPolicy` The type of origin steering policy to use. - `"random"`: Select an origin randomly. - `"hash"`: Select an origin by computing a hash over the CF-Connecting-IP address. - `"least_outstanding_requests"`: Select an origin by taking into consideration origin weights, as well as each origin's number of outstanding requests. Origins with more pending requests are weighted proportionately less relative to others. - `"least_connections"`: Select an origin by taking into consideration origin weights, as well as each origin's number of open connections. Origins with more open connections are weighted proportionately less relative to others. Supported for HTTP/1 and HTTP/2 connections. - `const OriginSteeringPolicyRandom OriginSteeringPolicy = "random"` - `const OriginSteeringPolicyHash OriginSteeringPolicy = "hash"` - `const OriginSteeringPolicyLeastOutstandingRequests OriginSteeringPolicy = "least_outstanding_requests"` - `const OriginSteeringPolicyLeastConnections OriginSteeringPolicy = "least_connections"` - `Origins []Origin` The list of origins within this pool. Traffic directed at this pool is balanced across all currently healthy origins, provided the pool itself is healthy. - `Address string` The IP address (IPv4 or IPv6) of the origin, or its publicly addressable hostname. Hostnames entered here should resolve directly to the origin, and not be a hostname proxied by Cloudflare. To set an internal/reserved address, virtual_network_id must also be set. - `DisabledAt Time` This field shows up only if the origin is disabled. This field is set with the time the origin was disabled. - `Enabled bool` Whether to enable (the default) this origin within the pool. Disabled origins will not receive traffic and are excluded from health checks. The origin will only be disabled for the current pool. - `Header Header` The request header is used to pass additional information with an HTTP request. Currently supported header is 'Host'. - `Host []Host` The 'Host' header allows to override the hostname set in the HTTP request. Current support is 1 'Host' header override per origin. - `Name string` A human-identifiable name for the origin. - `Port int64` The port for upstream connections. A value of 0 means the default port for the protocol will be used. - `VirtualNetworkID string` The virtual network subnet ID the origin belongs in. Virtual network must also belong to the account. - `Weight float64` The weight of this origin relative to other origins in the pool. Based on the configured weight the total traffic is distributed among origins within the pool. - `origin_steering.policy="least_outstanding_requests"`: Use weight to scale the origin's outstanding requests. - `origin_steering.policy="least_connections"`: Use weight to scale the origin's open connections. ### Example ```go package main import ( "context" "fmt" "github.com/cloudflare/cloudflare-go" "github.com/cloudflare/cloudflare-go/load_balancers" "github.com/cloudflare/cloudflare-go/option" ) func main() { client := cloudflare.NewClient( option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"), ) pool, err := client.LoadBalancers.Pools.Edit( context.TODO(), "17b5962d775c646f3f9725cbc7a53df4", load_balancers.PoolEditParams{ AccountID: cloudflare.F("023e105f4ecef8ad9ca31a8372d0c353"), }, ) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", pool.ID) } ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "result": { "id": "17b5962d775c646f3f9725cbc7a53df4", "check_regions": [ "WEU", "ENAM" ], "created_on": "2014-01-01T05:20:00.12345Z", "description": "Primary data center - Provider XYZ", "disabled_at": "2019-12-27T18:11:19.117Z", "enabled": false, "latitude": 0, "load_shedding": { "default_percent": 0, "default_policy": "random", "session_percent": 0, "session_policy": "hash" }, "longitude": 0, "minimum_origins": 0, "modified_on": "2014-01-01T05:20:00.12345Z", "monitor": "monitor", "monitor_group": "monitor_group", "name": "primary-dc-1", "networks": [ "string" ], "notification_email": "someone@example.com,sometwo@example.com", "notification_filter": { "origin": { "disable": true, "healthy": true }, "pool": { "disable": true, "healthy": false } }, "origin_steering": { "policy": "random" }, "origins": [ { "address": "0.0.0.0", "disabled_at": "2019-12-27T18:11:19.117Z", "enabled": true, "header": { "Host": [ "example.com" ] }, "name": "app-server-1", "port": 0, "virtual_network_id": "a5624d4e-044a-4ff0-b3e1-e2465353d4b4", "weight": 0.6 } ] }, "success": true } ```